*! version 1.0
*! A simple way to advance the Stata RNG state by a fixed amount
*! Will also fill a variable with a sequence of such states
program rng_advance
	version 12
	syntax anything [, var(string) amount(int 10)]
	
	rng_advance_`anything', var(`var') amount(`amount')
end

program rng_advance_replace
	version 12
	syntax , var(string) [amount(int 10)]
	forvalues i=1/`=_N' {
		replace `var'="`c(seed)'" in `i'
		rng_advance_step, amount(`amount')
	}
end

program rng_advance_step
	version 12
	syntax [, amount(int 10)]

	tempname tmp_mat
	mat tmp_mat = matuniform(`amount',1)
end
